class Pettanr.ScrollsController extends Pettanr.AppController
  
  index: () ->
    @trigger('title', @params)
    @filer_list()
    @trigger('done', @params)
  
  by_author: () ->
    @trigger('title', @params)
    @filer_list()
    @trigger('done', @params)
  
  by_panel: () ->
    @trigger('title', @params)
    @filer_list()
    @trigger('done', @params)
  
  show: () ->
    @listenTo(@cache, 'retrieve', @render_show)
    @set_show(@render_show)
  
  render_show: (@item) -> 
    switch @params['format']
      when 'prof'
        @show_prof()
      when 'html'
        @show_html()
  
  show_html: () -> 
    @trigger('title', @params, @item.get('title'))
    show = new Pettanr.Views.Scroll.Show({
      item: @item,
    })
    show.render()
    @trigger('ready', show)
    @trigger('done', @params)
  
  play: () ->
    @set_play(@render_play)
  
  render_play: (@item) ->
    @list.open(this, {
      success: (items) => 
        pager = Locmare.ListGroupModule.LibModule.PlayPager.factory(@list.page_status, @params)
        @trigger('title', @params, @item.get('title'))
        show = new Pettanr.Views.Scroll.Play({
          item: @item,
          list: @list,
          pager: pager
        })
        @listenTo(show, 'insert', @insert)
        @listenTo(show, 'move', @move)
        @listenTo(show, 'dialog:close', @close_dialog)
        show.render()
        @trigger('ready', show)
    })
    @trigger('done', @params)
  
  insert: (dialog) ->
    @lock(dialog)
  
  move: (dialog) ->
    @lock(dialog)
  
  lock: (dialog) ->
    @trigger('lock', @params, dialog)
  
  close_dialog: (dialog) ->
    @trigger('unlock', @params, dialog)
  
  new: () ->
    @trigger('title', @params)
    @form_new()
    @trigger('done', @params)
  
  edit: () ->
    @trigger('title', @params)
    @form_edit()
    @trigger('done', @params)
  
  create: () ->
    @form.item.overwrite({})
    @listenTo(@form, 'success', @post_success)
    @listenTo(@form, 'fail', @post_fail)
    @form.save()
  
  update: () ->
    @form.item.overwrite({})
    @listenTo(@form, 'success', @post_success)
    @listenTo(@form, 'fail', @post_fail)
    @form.save()
  
  destroy: () ->
    @set_show(@render_destroy)
  
  render_destroy: (@item) ->
    @listenTo(@item, 'destroy:success', @destroy_success)
    @listenTo(@item, 'destroy:fail', @destroy_fail)
    @item.destroy()
  
  @is_deny_action_on_picker: (params) ->
    switch params['action']
      when 'new'
        true
      when 'edit'
        true
      else
        false
  
