class Pettanr.GroundPicture extends Peta.Element
  
  @singular: () ->
    'GroundPicture'
  
  @plural: () ->
    'GroundPictures'
  
  defaults: {
    id: null,
    x: 0,
    y: 0,
    repeat: 0
  } 
  
  @repeat_texts: () -> 
    ['repeat', 'repeat-x', 'repeat-y', 'no-repeat']
  
  @pick_item_name: () ->
    'resource_picture'
  
  @traceable_item_names: () ->
    ['panel_picture', 'picture']
  
  pick: (picked_item) ->
    {picture_id: picked_item.get('picture_id')}
  
  @trace_routes: () ->
    {
      resource_picture: ['picture', 'resource_picture_picture', 'resource_picture'],
      symbol: 'picture'
    }
  
  @has_picture: () ->
    true
  
  tmb_opt_img_tag: (picture) ->
    new Pettanr.Image.SymbolPicture({
      attr: {
        src: picture.r_url(), 
        alt: @escape('caption')
      },
      picture: picture
    })
  
  repeat_text: () ->
    Pettanr.GroundPicture.repeat_texts()[@get('repeat')]
  
  element_face: () ->
    new Pettanr.Views.GroundPicture.ElementFace({element: this})
  
  picture_file: () ->
    new Pettanr.PictureFile(this)
  
  initialize: (attr, options) ->
    super(attr, options)
  
