class Pettanr.View.Show.Header extends Pettanr.View
  tagName: 'h1'
  className: 'show-header'
  
  initialize: (@item, options) ->
    @face_options = options.face
    @label_options = options.label
    @prof_options = options.prof
    
    @pick = null
    @face_button = @item.mini_face_button({
      context: this,
      class_name: 'icon',
      click: () =>
        @trigger('click:icon')
    })
    @label_button = @item.label_button({
      url: @label_options.url,
      context: this,
      class_name: 'caption',
      click: () =>
        @trigger('click:caption')
    })
    @prof_button = @item.mini_prof_button({
      context: this,
      class_name: 'prof',
      click: () =>
        @trigger('click:prof')
    })
  
  render: () ->
    this.$el.html('')
    this.$el.append(@pick.render().el) if @pick
    this.$el.append(@face_button.render().el)
    this.$el.append(@label_button.render().el)
    this.$el.append(@prof_button.render().el)
    this
  
  click_pick: () ->
    @trigger('click:pick')
  
  add_pick: (target_model) ->
    @pick = new Pettanr.Views.Common.PickIcon({
      name: target_model.pick_type(@item.item_name()), half: true
    })
    @listenTo(@pick, 'click', @click_pick)
    @render()
  
