class Pettanr.Views.Artist.ShowModule
class Pettanr.Views.Artist.ShowModule.Header extends Pettanr.Views.Show.Header
  
  initialize: (options) ->
    super(options)
  
class Pettanr.Views.Artist.ShowModule.ResourcePictures extends Pettanr.View
  
  initialize: (options) ->
    super(options)
    @item = options.item
  
  render: () ->
    params = {
      controller: 'resource_pictures', action: 'by_artist', id: @item.get('id'),
      page_size: 5
    }
    controller = Manifest.manifest().controllers[params['controller']]
    action = controller.actions[params['action']]
    @list = action.find(params)
    @list.to_filer(this, {
      success: (filer) => 
        pager = Locmare.ListGroupModule.LibModule.Pager.factory(@list.page_status, params)
        @listenTo(filer, 'http_get', @http_get)
        this.$el.append(filer.render().el)
    })
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
class Pettanr.Views.Artist.ShowModule.Body extends Pettanr.View
  
  initialize: (options) ->
    super(options)
    @item = options.item
    @resource_pictures = new Pettanr.Views.Artist.ShowModule.ResourcePictures({item: @item})
  
  render: () ->
    this.$el.html('')
    @listenTo(@resource_pictures, 'http_get', @http_get)
    this.$el.append(@resource_pictures.render().el)
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
class Pettanr.Views.Artist.Show extends Pettanr.View
  tagName: 'div'
  
  initialize: (options) ->
    @item = options.item
    @header = new Pettanr.Views.Artist.ShowModule.Header({
      item: @item, 
      caption: @item.get('name'), 
      icon_url: @item.show_url(),
      caption_url: @item.show_url(),
      prof_url: @item.prof_url()
    })
    @body = new Pettanr.Views.Artist.ShowModule.Body({
      item: @item, 
    })
    @listenTo(@body, 'http_get', @http_get)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@header.render().el)
    this.$el.append(@body.render().el)
    this
  
  http_get: (url) ->
    @trigger('http_get', url)
  
