require_dependency "editor/pool"
require_dependency "editor/dock"
require_dependency "editor/dock/dock"
module Editor
  class Editor
    include EditorModule
    cattr_accessor :eid
    @@eid = 0
    class Generator
      def initialize editor
        @editor = editor
      end
      
      def root_item
        @editor.root_item
      end
      
      def template_dir
        'templates/r/editor/'
      end
      
      def template_file_name
        'generator'
      end
      
      def template_name
        self.template_dir + self.template_file_name
      end
      
    end
    
    attr_accessor :root_item, :dock, :generator, :operators
    def initialize root_item, operators
      @@eid += 1
      @root_item = root_item
      @operators = operators
      @dock = self.new_dock
      @pool = Pool.new self, @root_item
      @generator = Generator.new self
      @@eid = 0 if @@eid > 0x7fffff
    end
    
    #InstanceMethods
    
    def name
      'owner'
    end
    
    def eid
      @@eid
    end
    
    def new_dock
      Dock.new self
    end
    
    def template_dir
      'templates/r/editor/'
    end
    
    def template_file_name
      'editor'
    end
    
    def template_name
      self.template_dir + self.template_file_name
    end
    
    def register
      @root_item.editor = self
      @root_item.each_elements(self.name) do |element|
        element.editor = self
        element.parent = @root_item
      end
    end
    
    def eid
      'editor-' + @@eid.to_s
    end
    
    def dom_id
      'editor-' + @root_item.id.to_s
    end
    
    def dom_class
      'editor'
    end
    
    def render view
      @docks.map {|element| 
        ElementTab.new self, element
      }
    end
  end
  
end
