ManifestBase.require_modules "local_manifest/form/use/field/", 
  %w|tag label helper|

module LocalManifest
  module FormModule
    module UseModule
      class Field < ManifestBase::NameValues
        include FieldModule
        
        attr :label, :tag, :helpers, :row_break, :boost_name
        
        def set_default
          super
          @values['label'] ||= {}
          @values['tag'] ||= {}
          @values['helpers'] ||= {}
          @values['row_break'] ||= true
        end
        
        def init
          super
          @label = ManifestBase.load_type_args self, @values, 'label', LabelFactory
          @tag = ManifestBase.load_type_args self, @values, 'tag', TagFactory
          @helpers = ManifestBase.load_type_name_args self, @values, 'helpers', HelperFactory
          @row_break = @values['row_break']
          # @boost_name = @values['boost_name']
        end
        
        def part?
          @part_name != nil 
        end
        
        def form_name
          self.form.name
        end
        
        def use_name
          @parent.name
        end
        
        def column_name
          @name
        end
        
        def item_name
          form_name
        end
        
        def use
          @parent
        end
        
        def form
          self.use.parent
        end
        
      end
      
    end
  end
end
