module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module SymbolItemColumnModule
            module DefaultModule
              module FaceModule
                class BaseFace
                  attr :default_symbol, :face_manifest, :item
                  def initialize default_symbol, face_manifest, item
                    @default_symbol = default_symbol
                    @face_manifest = face_manifest
                    @item = item
                  end
                  
                  def filer
                    @default_symbol.filer
                  end
                  
                  def manifest
                    self.filer.manifest
                  end
                  
                  def item_name
                    self.filer.item_name
                  end
                  
                  def template_dir
                    self.filer.template_dir + "symbol_face/"
                  end
                  
                  def template_file_name
                    raise "undefined template_file_name\n"
                  end
                  
                  def template_name
                    self.template_dir + self.template_file_name
                  end
                  
                end
                
                class ImageFace < BaseFace
                  def template_file_name
                    'image'
                  end
                  
                  def url
                    @face_manifest.url
                  end
                  
                  def tag_opt
                    {:src => self.url, :width => Manifest.manifest.magic_numbers['thumbnail_width'], :height => Manifest.manifest.magic_numbers['thumbnail_height']}
                  end
                  
                end
                
                class PictureFace < BaseFace
                  def template_file_name
                    'picture'
                  end
                  
                  def method_name
                    @face_manifest.method_name
                  end
                  
                  def tag_opt
                    if @item.methods(true).include?(self.method_name.to_sym)
                      @item.__send__ self.method_name
                    else
                      {:src => '/images/error.png', :width => Manifest.manifest.magic_numbers['thumbnail_width'], :height => Manifest.manifest.magic_numbers['thumbnail_height']}
                    end
                  end
                  
                end
                
              end
            end
          end
        end
      end
    end
  end
end
