require_dependency "locmare/form/field/tag/base"
require_dependency "locmare/form/field/tag/text"
require_dependency "locmare/form/field/tag/number"
require_dependency "locmare/form/field/tag/text_area"
require_dependency "locmare/form/field/tag/select"
require_dependency "locmare/form/field/tag/hidden"
module Locmare
  module FormModule
    module FieldModule
      class TagFactory
        include TagModule
        @@types = {
          'text' => TextTag, 'number' => NumberTag, 'text_area' => TextAreaTag, 
          'select' => SelectTag, 'hidden' => HiddenTag
        }
        def self.factory field, my_manifest
          type = my_manifest.type
          my_class = @@types[type]
          raise "undefined class for local view forms > #{field.form_name} > fields > #{field.field_name} > tag > #{type}\n" unless my_class
          my_class.new(field, my_manifest)
        end
        
      end
      
    end
  end
end
