module Locmare
  module FormModule
    module FieldModule
      module TagModule
        class Base
          attr :field, :tag_manifest
          
          def initialize field, tag_manifest
            @field = field
            @tag_manifest = tag_manifest
          end
          
          def form_field_name
            @field.form_field_name
          end
          
          def value
            @field.value
          end
          
          def options
            @field.options @tag_manifest.options
          end
          
          def form
            @field.form
          end
          
          def manifest
            self.form.manifest
          end
          
          def form_name
            self.form.form_name
          end
          
          def model
            self.form.model
          end
          
          def item
            self.form.item
          end
          
          def template_dir
            self.form.template_dir + 'tag/'
          end
          
          def template_file_name
            raise "undefined template_file_name\n"
          end
          
          def template_name
            self.template_dir + self.template_file_name
          end
          
        end
        
      end
    end
  end
end
