module Peta
  class ElementNestableContent < Content
    self.abstract_class = true
    
    # Dynamic Methods
    
    def self.load_manifest
      super
      return nil if self._skip_load?
      # Class Methods
      # Instance Methods
      define_method("element_items") do |element_model|
        self.__send__ self.class.my_manifest.associations.child_element_name(element_model)
      end
      define_method("elements_items") do 
        self.class.child_models.map {|element_model|
          self.element_items element_model
        }.flatten
      end
    end
    
    # Class Methods
    
    # Instance Methods
    
    def boosts level
      super
      self.elements_items.each do |item|
        item.boosts level
      end
    end
    
    def post_attributes opt = {}
      attr = self.copy_attributes(opt)
      associations_attr = {}
      self.class.child_models.each do |element_model|
        name = self.class.my_manifest.associations.child_element_name(element_model) + '_attributes'
        if self.class.my_manifest.associations.has_one?(element_model)
          e = self.element_items(element_model).post_attributes(opt)
        else
          e = {}
          self.element_items(element_model).each do |element|
            e[element.post_attribute_key] = element.post_attributes(opt)
          end
        end
        associations_attr[name] = e
      end
      attr.merge! associations_attr
      attr
    end
    
  end
end

